/* -*-as3-*-  Prototype file of KM-yacc parser for ActionScript 3.
 *
 * Written by MORI Koichiro
 * Translated from Java to ActionScript 3 by Yu Kobayashi
 *
 * This file is PUBLIC DOMAIN.
 */


/* Here goes %{ ... %} */

// -- head.begin
package {
    import flash.display.*;
    import flash.text.*;
    
    import mx.controls.Image;
    public class Calc extends Image {
      public static var _i:Calc; // main instance
      public function Calc() {
        _i = this;
      }
      public function Run(str:String):void {
      	str = str.replace(/\r/g,"\n");
        var cp:CalcParser = new CalcParser();
        cp.inputString = str + "\n";
        CalcParser.yydebug = true;
        CalcParser.yyDumpParseTree = true;
        cp.yyparse();
      }
      // output command
      private static var output_y:Number = 0;
      public static function output(v:String):void {
      	
      }
    }
}
// -- head.end


class CalcParser {


  public const YYERRTOK:int = 256;
  public const NUMBER:int = 257;
  public const WORD:int = 258;

  
  /*
    #define yyclearin (yychar = -1)
    #define yyerrok (yyerrflag = 0)
    #define YYRECOVERING (yyerrflag != 0)
    #define YYERROR  goto yyerrlab
  */


  /** Debug mode flag **/
  public static var yydebug:Boolean = false;

  /** lexical element object **/
  private var yylval:Object;

  /** Semantic value */
  private var yyval:Object;

  /** Semantic stack **/
  private var yyastk:Array;

  /** Syntax stack **/
  private var yysstk:Array;

  /** Stack pointer **/
  private var yysp:int;

  /** Error handling state **/
  private var yyerrflag:int;

  /** lookahead token **/
  private var yychar:int;

  /* code after %% in *.y */
  
  /* Lexical analyzer */
  
  private var ch:String = null;
  public var inputString:String;
  private var inputPos:int=0;
  private var calc_vars:Object = {};
  
  private function getch():String {
    var c:String = ch;
    if (c != null) {
      ch = null;
      return c;
    }
    if(inputPos >= inputString.length) {
      return null;
    }
    return inputString.charAt(inputPos++);
  }
  private function ungetch(c:String):void { ch = c; }
  private function isDigit(s:String):Boolean {
    s = s.charAt(0);
    return ("0" <= s && s <= "9");
  }
  private function isAlpha(s:String):Boolean {
    s = s.charAt(0);
    return ("a" <= s && s <= "z" || s == "_" || "A" <= s && s <= "Z");
  }
  
  private function yylex():int {
  	var r:int = _yylex();
  	trace("--"+r);
  	return r;
  }
  private function _yylex():int {
    yylval = null;
    for (;;) {
      var c:String = getch();
      if (c == null) {
        return 0;
      } else if (c == ' ' || c == '\t') {
        // skip
      } else if (isDigit(c)) {
        var n:String = "";
        while (c != null && isDigit(c)) {
          n += c;
          c = getch();
        }
        ungetch(c);
        yylval = parseInt(n);
        return NUMBER;
      } else if (isAlpha(c)) {
        var id:String = "";
        while (c != null && isAlpha(c)) {
          id += c;
          c = getch();
        }
        ungetch(c);
        yylval = id;
        return WORD;
      } else {
        return c.charCodeAt(0);
      }
    }
    throw "Doesn't come here";
  }
  
  private function yyerror(msg:String):void {
    trace(msg);
  }

  /* Dump Parse Tree Flag */
  public static var yyDumpParseTree:Boolean = false;

  /* Dense Tree */
  public static var yydense:Boolean = false;


  /* Parse Tree Stack */
  private var yyPTStack:Array;


  public static const yyterminals:Array = [
    "$EOF",
    "error",
    "NUMBER",
    "WORD",
    "'+'",
    "'-'",
    "'*'",
    "'/'",
    "'%'",
    "'>'",
    "'\\n'",
    "'='",
    "'('",
    "')'"
    , "???"
  ];

  public static const yynonterms:Array = [
    "$start",
    "start",
    "lines",
    "line",
    "expr"
  ];

  private function yytokname(n:int):String {
    switch (n) {
    case 0: return "$EOF";
    case 256: return "error";
    case 257: return "NUMBER";
    case 258: return "WORD";
    case 43: return "'+'";
    case 45: return "'-'";
    case 42: return "'*'";
    case 47: return "'/'";
    case 37: return "'%'";
    case 62: return "'>'";
    case 10: return "'\\n'";
    case 61: return "'='";
    case 40: return "'('";
    case 41: return "')'";
    default:
        return "???";
    }
  }

  private const yyproduction:Array = [
    "$start : start",
    "start : lines",
    "lines : /* empty */",
    "lines : lines line",
    "line : '>' expr '\\n'",
    "line : WORD '=' expr '\\n'",
    "line : '\\n'",
    "line : error '\\n'",
    "expr : expr '+' expr",
    "expr : expr '-' expr",
    "expr : expr '*' expr",
    "expr : expr '/' expr",
    "expr : expr '%' expr",
    "expr : '(' expr ')'",
    "expr : NUMBER",
    "expr : WORD"
  ];

  /* Traditional Debug Mode */
  private function YYTRACE_NEWSTATE(state:int, sym:int):void {
    if (yydebug)
      trace("% State " + state + ", Lookahead "
                         + (sym < 0 ? "--none--" : yyterminals[sym]));
  }

  private function YYTRACE_READ(sym:int):void {
    if (yydebug)
      trace("% Reading " + yyterminals[sym]);
  }

  private function YYTRACE_SHIFT(sym:int):void {
    if (yydebug)
      trace("% Shift " + yyterminals[sym]);
  }

  private function YYTRACE_ACCEPT():void {
    if (yydebug) trace("% Accepted.");
  }

  private function YYTRACE_REDUCE(n:int):void {
    if (yydebug)
      trace("% Reduce by (" + n + ") " + yyproduction[n]);
  }

  private function YYTRACE_POP(state:int):void {
    if (yydebug)
	trace("% Recovering, uncovers state " + state);
  }

  private function YYTRACE_DISCARD(sym:int):void {
    if (yydebug)
      trace("% Discard " + yyterminals[sym]);
  }


  private const yytranslate:Array = [
      0,   14,   14,   14,   14,   14,   14,   14,   14,   14,
     10,   14,   14,   14,   14,   14,   14,   14,   14,   14,
     14,   14,   14,   14,   14,   14,   14,   14,   14,   14,
     14,   14,   14,   14,   14,   14,   14,    8,   14,   14,
     12,   13,    6,    4,   14,    5,   14,    7,   14,   14,
     14,   14,   14,   14,   14,   14,   14,   14,   14,   14,
     14,   11,    9,   14,   14,   14,   14,   14,   14,   14,
     14,   14,   14,   14,   14,   14,   14,   14,   14,   14,
     14,   14,   14,   14,   14,   14,   14,   14,   14,   14,
     14,   14,   14,   14,   14,   14,   14,   14,   14,   14,
     14,   14,   14,   14,   14,   14,   14,   14,   14,   14,
     14,   14,   14,   14,   14,   14,   14,   14,   14,   14,
     14,   14,   14,   14,   14,   14,   14,   14,   14,   14,
     14,   14,   14,   14,   14,   14,   14,   14,   14,   14,
     14,   14,   14,   14,   14,   14,   14,   14,   14,   14,
     14,   14,   14,   14,   14,   14,   14,   14,   14,   14,
     14,   14,   14,   14,   14,   14,   14,   14,   14,   14,
     14,   14,   14,   14,   14,   14,   14,   14,   14,   14,
     14,   14,   14,   14,   14,   14,   14,   14,   14,   14,
     14,   14,   14,   14,   14,   14,   14,   14,   14,   14,
     14,   14,   14,   14,   14,   14,   14,   14,   14,   14,
     14,   14,   14,   14,   14,   14,   14,   14,   14,   14,
     14,   14,   14,   14,   14,   14,   14,   14,   14,   14,
     14,   14,   14,   14,   14,   14,   14,   14,   14,   14,
     14,   14,   14,   14,   14,   14,   14,   14,   14,   14,
     14,   14,   14,   14,   14,   14,    1,    2,    3
  ];
  private const YYBADCH:int = 14;
  private const YYMAXLEX:int = 259;
  private const YYTERMS:int = 14;
  private const YYNONTERMS:int = 5;

  private const yyaction:Array = [
     22,   -1,   16,    0,   17,   25,   23,   32,   33,    6,
      5,   24,    8,    9,   10,   11,   12,    7,-32766,-32766,
     31
  ];
  private const YYLAST:int = 21;

  private const yycheck:Array = [
     10,    0,    1,    0,    3,   10,   10,    2,    3,   11,
      9,   10,    4,    5,    6,    7,    8,   12,    4,    5,
     13
  ];

  private const yybase:Array = [
      0,  -10,   -4,    7,    1,    5,    5,    5,    5,    5,
      5,    5,    5,   14,   14,    3,   -5,   -2,    0,    8,
      8,    8,    0,    0,    0,    0,    0,    0,    0,    0,
      0,    8,    8
  ];
  private const YY2TBLSTATE:int = 15;

  private const yydefault:Array = [
      2,32767,32767,32767,32767,32767,32767,32767,32767,32767,
  32767,32767,32767,    8,    9,32767,32767,32767
  ];

  private const yygoto:Array = [
      2,    3,   13,   14,   28,   29,   30
  ];
  private const YYGLAST:int = 7;

  private const yygcheck:Array = [
      4,    4,    4,    4,    4,    4,    4
  ];

  private const yygbase:Array = [
      0,    0,    0,    0,   -6
  ];

  private const yygdefault:Array = [
  -32768,   15,    4,   21,    1
  ];

  private const yylhs:Array = [
      0,    1,    2,    2,    3,    3,    3,    3,    4,    4,
      4,    4,    4,    4,    4,    4
  ];

  private const yylen:Array = [
      1,    1,    0,    2,    3,    4,    1,    2,    3,    3,
      3,    3,    3,    3,    1,    1
  ];
  private const YYSTATES:int = 29;
  private const YYNLSTATES:int = 18;
  private const YYINTERRTOK:int = 1;
  private const YYUNEXPECTED:int = 32767;
  private const YYDEFAULT:int = -32766;

  private const YYDEFAULTSTACK:int = 512;

  /* Grow syntax and sematic stacks */
  private function growStack():void {
    var tmpsstk:Array = new Array(yysp * 2);
    var tmpastk:Array = new Array(yysp * 2);
    for (var i:int = 0; i < yysp; i++) {
      tmpsstk[i] = yysstk[i];
      tmpastk[i] = yyastk[i];
    }
    yysstk = tmpsstk;
    yyastk = tmpastk;
  }

  /*
   * Parser entry point
   */
  public function yyparse():int {
    var yyn:int;
    var yyp:int;
    var yyl:int;

    yyastk = new Array(YYDEFAULTSTACK);
    yysstk = new Array(YYDEFAULTSTACK);
    if (yyDumpParseTree)
      yyPTStack = new Array(YYDEFAULTSTACK);

    var yystate:int = 0;
    var yychar1:int = yychar = -1;

    yysp = 0;
    yysstk[yysp] = 0;
    yyerrflag = 0;
    for (;;) {
      YYTRACE_NEWSTATE(yystate, yychar1);
      if (yybase[yystate] == 0)
        yyn = yydefault[yystate];
      else {
        if (yychar < 0) {
          if ((yychar = yylex()) <= 0) yychar = 0;
          yychar1 = yychar < YYMAXLEX ? yytranslate[yychar] : YYBADCH;
          YYTRACE_READ(yychar1);
        }

        if (((yyn = yybase[yystate] + yychar1) >= 0
             && yyn < YYLAST && yycheck[yyn] == yychar1
             || (yystate < YY2TBLSTATE
                 && (yyn = yybase[yystate + YYNLSTATES] + yychar1) >= 0
                 && yyn < YYLAST && yycheck[yyn] == yychar1))
            && (yyn = yyaction[yyn]) != YYDEFAULT) {
          /*
           * >= YYNLSTATE: shift and reduce
           * > 0: shift
           * = 0: accept
           * < 0: reduce
           * = -YYUNEXPECTED: error
           */
          if (yyn > 0) {
            /* shift */
            YYTRACE_SHIFT(yychar1);
            if (++yysp >= yysstk.length)
              growStack();

            yysstk[yysp] = (int)(yystate = yyn);
            yyastk[yysp] = yylval;
            if (yyDumpParseTree)
	      yyPTStack[yysp] = new YYLeaf(yychar1, yylval);
            yychar1 = yychar = -1;

            if (yyerrflag > 0)
              yyerrflag--;
            if (yyn < YYNLSTATES)
              continue;
            
            /* yyn >= YYNLSTATES means shift-and-reduce */
            yyn -= YYNLSTATES;
          } else
            yyn = -yyn;
        } else
          yyn = yydefault[yystate];
      }
      
      for (;;) {
        /* reduce/error */
        if (yyn == 0) {
          /* accept */
          YYTRACE_ACCEPT();
	  if (yyDumpParseTree) {
	    yyPTStack[yysp].prettyPrint();
	  }
          return 0;
        }

	var yyparseerror:Boolean = true;
	if (yyn != YYUNEXPECTED) {
          /* reduce */
	  yyparseerror = false;
          yyl = yylen[yyn];
          yyval = yyastk[yysp-yyl+1];
          YYTRACE_REDUCE(yyn);
	  var yylrec:int = 0;
          /* Following line will be replaced by reduce actions */
          switch(yyn) {
          case 3:
{ yylrec++; } break;
          case 4:
{ Calc.output( yyastk[yysp-(3-2)] ); } break;
          case 5:
{ calc_vars[yyastk[yysp-(4-1)]] = yyastk[yysp-(4-3)]; } break;
          case 6:
{ trace("(empty line ignored)"); } break;
          case 8:
{ yyval = yyastk[yysp-(3-1)] + yyastk[yysp-(3-3)]; } break;
          case 9:
{ yyval = yyastk[yysp-(3-1)] - yyastk[yysp-(3-3)]; } break;
          case 10:
{ yyval = yyastk[yysp-(3-1)] * yyastk[yysp-(3-3)]; } break;
          case 11:
{ yyval = yyastk[yysp-(3-1)] / yyastk[yysp-(3-3)]; } break;
          case 12:
{ yyval = (yyastk[yysp-(3-1)]) % (yyastk[yysp-(3-3)]); } break;
          case 13:
{ yyval = yyastk[yysp-(3-2)]; } break;
          case 14:
{ yyval = yyastk[yysp-(1-1)]; } break;
          case 15:
{ yyval = calc_vars[yyastk[yysp-(1-1)]]; } break;
          }
	  if (!yyparseerror) {
	    if (yyDumpParseTree) {
	      if (yylrec != 0)
	        (yyPTStack[yysp-yyl+1]).appendKids(yyPTStack, yysp-yyl+2, yyl-1);
	      else
	        yyPTStack[yysp-yyl+1] = new YYNode(yylhs[yyn], yyPTStack, yysp-yyl+1, yyl);
	    }
            /* Goto - shift nonterminal */
            yysp -= yyl;
            yyn = yylhs[yyn];
            if ((yyp = yygbase[yyn] + yysstk[yysp]) >= 0 && yyp < YYGLAST
                && yygcheck[yyp] == yyn)
              yystate = yygoto[yyp];
            else
              yystate = yygdefault[yyn];
          
            if (++yysp >= yysstk.length)
              growStack();

            yysstk[yysp] = yystate;
            yyastk[yysp] = yyval;
	  }
	}

	if (yyparseerror) {
          /* error */
          switch (yyerrflag) {
          case 0:
            yyerror("syntax error");
          case 1:
          case 2:
            yyerrflag = 3;
            /* Pop until error-expecting state uncovered */

            while (!((yyn = yybase[yystate] + YYINTERRTOK) >= 0
                     && yyn < YYLAST && yycheck[yyn] == YYINTERRTOK
                     || (yystate < YY2TBLSTATE
                         && (yyn = yybase[yystate + YYNLSTATES] + YYINTERRTOK) >= 0
                         && yyn < YYLAST && yycheck[yyn] == YYINTERRTOK))) {
              if (yysp <= 0)
                return 1;
              yystate = yysstk[--yysp];
              YYTRACE_POP(yystate);
            }
            yyn = yyaction[yyn];
            YYTRACE_SHIFT(YYINTERRTOK);
            yysstk[++yysp] = (int)(yystate = yyn);
            if (yyDumpParseTree)
	      yyPTStack[yysp] = new YYLeaf(YYINTERRTOK, null);
            break;

          case 3:
            YYTRACE_DISCARD(yychar1);
            if (yychar1 == 0)
              return 1;
	    yychar1 = yychar = -1;
            break;
          }
        }
        
        if (yystate < YYNLSTATES)
          break;
        /* >= YYNLSTATES means shift-and-reduce */
        yyn = yystate - YYNLSTATES;
      }
    }
    return 0;
  }

}

  /** Parse Tree **/
  class YYParseTree {
    public function prettyPrint():void {
      prettyPrintX("", true);
    }

    public function prettyPrintX(head:String, last:Boolean):void {}
  }
  
  /** YYNode represents nonterminal symbol. **/
  class YYNode extends YYParseTree {
    private var id:int;
    private var nkids:int;
    private var kids:Array;

    public function YYNode(id:int, stack:Array, from:int, len:int) {
      this.id = id;
      nkids = len;
      kids = new Array(len);
      for (var i:int = 0; i < len; i++)
        kids[i] = stack[from + i];
    }


    public function appendKids(stack:Array, from:int, len:int):void {
      if (nkids + len > kids.length) {
        var size:int = kids.length * 2;
	if (size < nkids + len) size = nkids + len;
        var a:Array = new Array(size);
        for (var i:int = 0; i < nkids; i++)
          a[i] = kids[i];
        kids = a;
      }
      for (var j:int = 0; j < len; j++)
        kids[nkids + j] = stack[from + j];
      nkids += len;
    }


    public override function prettyPrintX(head:String, last:Boolean):void {
      var head2:String = head;
      if (head != "") {
        if (last)
          head2 = head + " +-"; /* L */
        else
          head2 = head + " +-"; /* T-rotated-left */
      }
      trace(head2 + CalcParser.yynonterms[id]);
      head += last ? "   " : " | ";

      for (var i:int = 0; i < nkids; i++) {
        if (!CalcParser.yydense)
          trace(head + " | ");
        if (i + 1 != nkids)
          kids[i].prettyPrintX(head, false);
        else
          kids[i].prettyPrintX(head, true);
      }
    }

    public function toString():String {
      var buf:String = "";
      buf += "(";
      buf += CalcParser.yynonterms[id];
      for (var i:int = 0; i < nkids; i++) {
        buf += " ";
        buf += kids[i].toString();
      }
      buf + ")";
      return buf;
    }
  }

  /** YYLeaf represents terminal symbol. **/
  class YYLeaf extends YYParseTree {
    private var id:int;
    private var value:Object;

    public function YYLeaf(id:int, value:Object) {
      this.id = id;
      this.value = value;
    }

    public override function prettyPrintX(head:String, last:Boolean):void {
      var head2:String = head;
      if (head != "") {
        if (last)
          head2 = head + " +-"; /* L */
        else
          head2 = head + " +-"; /* T-rotated-left */
      }
      trace(head2 + toString());
    }

    public function toString():String {
      if (value != null)
        return CalcParser.yyterminals[id] + "[" + value.toString() + "]";
      else
        return CalcParser.yyterminals[id];
    }
  }


