package TekitoBasic
{
	import TekitoBasic.nodes.*;
	
	public class TBMachine
	{
		private var vstack:Array = [];
		private var variables:Array = [];
		public var for_stack:Array = [];
		private var parser:TBParser;
		public var debug:Boolean = true;
		public var labels:Object = {};
		public var cur_node:TBNode;
		public var flag_jump:Boolean = false;
		public var flag_quit:Boolean = false;
		public function TBMachine(parser:TBParser)
		{
			this.parser = parser;
		}
		public function run(node:TBNode):void
		{
			var _cur_node:TBNode 	= cur_node;
			var _flag_jump:Boolean 	= flag_jump;
			cur_node = node;
			while (cur_node != null) {
				if (debug) trace("run:", cur_node.token.lineno, ":", cur_node.token.value);
				if (flag_quit) break;
				flag_jump = false;
				cur_node.execute(this);
				if (flag_jump == false) {
					cur_node = cur_node.next;	
				}
			}
			cur_node  = _cur_node;
			flag_jump = _flag_jump;
		}
		public function jump(label:String):void
		{
			if (parser.labels[label] != undefined) {
				flag_jump = true;
				cur_node = parser.labels[label];
			}
		}
		public function jumpNode(node:TBNode):void
		{
			flag_jump = true;
			cur_node = node;
		}
		public function pushValue(v:Object):void
		{
			if (debug) trace("push:", v);
			vstack.push(v);
		}
		public function popValue():Object
		{
			var v:Object = vstack.pop();
			if (debug) trace("push:", v);
			return v;
		}
		public function getVariable(name:String):TBVariable
		{
			if (variables[name] == undefined) {
				variables[name] = new TBVariable();
			}
			return variables[name];
		}
	}
}