/* -*-as3-*-  Prototype file of KM-yacc parser for ActionScript 3.
 *
 * Written by MORI Koichiro
 * Translated from Java to ActionScript 3 by Yu Kobayashi
 * 2008-03-03 changed by kujirahand
 *
 * This file is PUBLIC DOMAIN.
 */


/* Here goes %{ ... %} : $(CLASSNAME) */

// -- head.begin
package TekitoBasic
{
    import flash.display.*;
    import flash.text.*;
    import TekitoBasic.nodes.*;
    public class TBParser
    {
// -- head.end


  public const YYERRTOK:int = 256;
  public const EOL:int = 257;
  public const INT:int = 258;
  public const NUMBER:int = 259;
  public const STR:int = 260;
  public const LABEL:int = 261;
  public const WORD:int = 262;
  public const FUNCTION:int = 263;
  public const IF:int = 264;
  public const THEN:int = 265;
  public const ELSE:int = 266;
  public const FOR:int = 267;
  public const TO:int = 268;
  public const NEXT:int = 269;
  public const GOTO:int = 270;
  public const OR:int = 271;
  public const AND:int = 272;
  public const MOD:int = 273;
  public const GT:int = 274;
  public const GTEQ:int = 275;
  public const LT:int = 276;
  public const LTEQ:int = 277;
  public const NOTEQ:int = 278;
  public const NOT:int = 279;

  
  /*
    #define yyclearin (yychar = -1)
    #define yyerrok (yyerrflag = 0)
    #define YYRECOVERING (yyerrflag != 0)
    #define YYERROR  goto yyerrlab
  */


  /** Debug mode flag **/
  public static var yydebug:Boolean = false;

  /** lexical element object **/
  private var yylval:Object;

  /** Semantic value */
  private var yyval:Object;

  /** Semantic stack **/
  private var yyastk:Array;

  /** Syntax stack **/
  private var yysstk:Array;

  /** Stack pointer **/
  private var yysp:int;

  /** Error handling state **/
  private var yyerrflag:int;

  /** lookahead token **/
  private var yychar:int;

  /* code after %% in *.y */
  
  // -- footer.begin
      	public function TBParser()
      	{
      	}
      	public function compile():Boolean
      	{
      		// option
  	        yydebug 			= true;
  	        yyDumpParseTree 	= true;
  	        // parser
  	        topnode = new TBNode();
  	        topnode.token = new TBToken(0, "[topnode]", 0);
  	        gen = new TBParserGen(this);
  	        yyparse();
  	        return result;
      	}
      	public function run():Boolean
      	{
      		return true;
      	}
  		// lex
  		public var lex:TBLex;
  		public var topnode:TBNode;
  		private var cur_token:TekitoBasic.TBToken;
  		private var gen: TBParserGen;
  		private var result:Boolean = true;
  		public var error_message:String = "";
  		private function yylex():int {
  			yylval = null;
  			cur_token = lex.next();
  			if (cur_token == null) return 0;
  			yylval = cur_token;
  			return cur_token.type;
  		}
      	//
  		public var labels:Object = {};
  		//
  		private function yyerror(msg:String):void {
  			result = false;
  	  		var s:String = "[ERROR](" + cur_token.lineno + "): " + msg + "\n";
  	  		trace(s);
  			error_message += s;
  		}
  // -- footer.end
  

  /* Dump Parse Tree Flag */
  public var yyDumpParseTree:Boolean = false;

  /* Dense Tree */
  public var yydense:Boolean = false;


  /* Parse Tree Stack */
  private var yyPTStack:Array;


  public const yyterminals:Array = [
    "$EOF",
    "error",
    "EOL",
    "INT",
    "NUMBER",
    "STR",
    "LABEL",
    "WORD",
    "FUNCTION",
    "IF",
    "THEN",
    "ELSE",
    "FOR",
    "TO",
    "NEXT",
    "GOTO",
    "OR",
    "AND",
    "MOD",
    "GT",
    "GTEQ",
    "LT",
    "LTEQ",
    "NOTEQ",
    "'='",
    "'+'",
    "'-'",
    "'*'",
    "'/'",
    "'%'",
    "':'",
    "','",
    "'('",
    "')'",
    "'['",
    "']'"
    , "???"
  ];

  public const yynonterms:Array = [
    "$start",
    "start",
    "lines",
    "line",
    "programs",
    "program",
    "args",
    "if_block",
    "goto_block",
    "for_block",
    "next_block",
    "variable",
    "expr"
  ];

  public function yytokname(n:int):String {
    switch (n) {
    case 0: return "$EOF";
    case 256: return "error";
    case 257: return "EOL";
    case 258: return "INT";
    case 259: return "NUMBER";
    case 260: return "STR";
    case 261: return "LABEL";
    case 262: return "WORD";
    case 263: return "FUNCTION";
    case 264: return "IF";
    case 265: return "THEN";
    case 266: return "ELSE";
    case 267: return "FOR";
    case 268: return "TO";
    case 269: return "NEXT";
    case 270: return "GOTO";
    case 271: return "OR";
    case 272: return "AND";
    case 273: return "MOD";
    case 274: return "GT";
    case 275: return "GTEQ";
    case 276: return "LT";
    case 277: return "LTEQ";
    case 278: return "NOTEQ";
    case 61: return "'='";
    case 43: return "'+'";
    case 45: return "'-'";
    case 42: return "'*'";
    case 47: return "'/'";
    case 37: return "'%'";
    case 58: return "':'";
    case 44: return "','";
    case 40: return "'('";
    case 41: return "')'";
    case 91: return "'['";
    case 93: return "']'";
    default:
        return "???";
    }
  }

  private const yyproduction:Array = [
    "$start : start",
    "start : lines",
    "lines : /* empty */",
    "lines : lines line",
    "line : LABEL programs EOL",
    "line : LABEL ':' programs EOL",
    "line : EOL",
    "line : error EOL",
    "programs : program",
    "programs : programs ':' program",
    "program : FUNCTION args",
    "program : FUNCTION",
    "program : if_block",
    "program : goto_block",
    "program : for_block",
    "program : next_block",
    "program : variable '=' expr",
    "if_block : IF expr THEN INT",
    "if_block : IF expr THEN INT ELSE INT",
    "goto_block : GOTO INT",
    "for_block : FOR WORD '=' expr TO expr",
    "next_block : NEXT",
    "args : expr",
    "args : args ',' expr",
    "expr : expr '+' expr",
    "expr : expr '-' expr",
    "expr : expr '*' expr",
    "expr : expr '/' expr",
    "expr : expr '%' expr",
    "expr : expr MOD expr",
    "expr : expr GT expr",
    "expr : expr GTEQ expr",
    "expr : expr LT expr",
    "expr : expr LTEQ expr",
    "expr : expr NOTEQ expr",
    "expr : expr '=' expr",
    "expr : expr AND expr",
    "expr : expr OR expr",
    "expr : '(' expr ')'",
    "expr : NUMBER",
    "expr : INT",
    "expr : STR",
    "expr : variable",
    "variable : WORD",
    "variable : variable '[' expr ']'"
  ];

  /* Traditional Debug Mode */
  private function YYTRACE_NEWSTATE(state:int, sym:int):void {
    if (yydebug)
      trace("% State " + state + ", Lookahead "
                         + (sym < 0 ? "--none--" : yyterminals[sym]));
  }

  private function YYTRACE_READ(sym:int):void {
    if (yydebug)
      trace("% Reading " + yyterminals[sym]);
  }

  private function YYTRACE_SHIFT(sym:int):void {
    if (yydebug)
      trace("% Shift " + yyterminals[sym]);
  }

  private function YYTRACE_ACCEPT():void {
    if (yydebug) trace("% Accepted.");
  }

  private function YYTRACE_REDUCE(n:int):void {
    if (yydebug)
      trace("% Reduce by (" + n + ") " + yyproduction[n]);
  }

  private function YYTRACE_POP(state:int):void {
    if (yydebug)
	  trace("% Recovering, uncovers state " + state);
  }

  private function YYTRACE_DISCARD(sym:int):void {
    if (yydebug)
      trace("% Discard " + yyterminals[sym]);
  }


  private const yytranslate:Array = [
      0,   36,   36,   36,   36,   36,   36,   36,   36,   36,
     36,   36,   36,   36,   36,   36,   36,   36,   36,   36,
     36,   36,   36,   36,   36,   36,   36,   36,   36,   36,
     36,   36,   36,   36,   36,   36,   36,   29,   36,   36,
     32,   33,   27,   25,   31,   26,   36,   28,   36,   36,
     36,   36,   36,   36,   36,   36,   36,   36,   30,   36,
     36,   24,   36,   36,   36,   36,   36,   36,   36,   36,
     36,   36,   36,   36,   36,   36,   36,   36,   36,   36,
     36,   36,   36,   36,   36,   36,   36,   36,   36,   36,
     36,   34,   36,   35,   36,   36,   36,   36,   36,   36,
     36,   36,   36,   36,   36,   36,   36,   36,   36,   36,
     36,   36,   36,   36,   36,   36,   36,   36,   36,   36,
     36,   36,   36,   36,   36,   36,   36,   36,   36,   36,
     36,   36,   36,   36,   36,   36,   36,   36,   36,   36,
     36,   36,   36,   36,   36,   36,   36,   36,   36,   36,
     36,   36,   36,   36,   36,   36,   36,   36,   36,   36,
     36,   36,   36,   36,   36,   36,   36,   36,   36,   36,
     36,   36,   36,   36,   36,   36,   36,   36,   36,   36,
     36,   36,   36,   36,   36,   36,   36,   36,   36,   36,
     36,   36,   36,   36,   36,   36,   36,   36,   36,   36,
     36,   36,   36,   36,   36,   36,   36,   36,   36,   36,
     36,   36,   36,   36,   36,   36,   36,   36,   36,   36,
     36,   36,   36,   36,   36,   36,   36,   36,   36,   36,
     36,   36,   36,   36,   36,   36,   36,   36,   36,   36,
     36,   36,   36,   36,   36,   36,   36,   36,   36,   36,
     36,   36,   36,   36,   36,   36,    1,    2,    3,    4,
      5,    6,    7,    8,    9,   10,   11,   12,   13,   14,
     15,   16,   17,   18,   19,   20,   21,   22,   23,   36
  ];
  private const YYBADCH:int = 36;
  private const YYMAXLEX:int = 280;
  private const YYTERMS:int = 36;
  private const YYNONTERMS:int = 13;

  private const yyaction:Array = [
     26,   27,   28,   29,   30,   31,   32,   33,   34,   35,
     36,   37,   38,   39,  101,   20,   21,-32766,-32766,   50,
     28,   79,   51,   98,   97,   99,    0,  101,   77,   37,
     38,   39,   -1,   49,   64,   35,   36,   65,   11,   63,
     62,   54,   56,   76,   57,   40,   55,   23,   13,   12,
     96,  102,   22,   25,   41,    0,    0,    0,   24
  ];
  private const YYLAST:int = 59;

  private const yycheck:Array = [
     16,   17,   18,   19,   20,   21,   22,   23,   24,   25,
     26,   27,   28,   29,    7,    8,    9,   16,   17,   12,
     18,   14,   15,    3,    4,    5,    0,    7,    3,   27,
     28,   29,    0,    1,    2,   25,   26,    2,    6,    2,
      2,    7,    3,    3,   11,   24,   10,   24,   30,   30,
     33,   35,   32,   31,   13,   -1,   -1,   -1,   34
  ];

  private const yybase:Array = [
      0,   36,   17,   16,   41,  -16,  -16,  -16,  -16,    1,
      1,   19,    7,    7,   10,   10,   10,   10,   10,   10,
     20,   20,   20,   20,   20,   20,   20,   20,   20,   20,
     20,   20,   20,   20,   20,   20,   20,   20,   20,   20,
     20,   20,   32,    2,    2,   38,   23,   37,   26,   35,
     34,   25,   22,   24,   21,   39,   33,   40,    0,  -16,
    -16,  -16,  -16,    0,    0,    0,    0,  -16,  -16,    7,
      0,    0,    2,    2,    2,    2,    2,    2,    0,    0,
      0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
      0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
      0,    0,    0,   18,   24,   18
  ];
  private const YY2TBLSTATE:int = 48;

  private const yydefault:Array = [
      2,32767,32767,32767,32767,   22,   16,   23,   20,   37,
     36,32767,32767,32767,   30,   31,   32,   33,   34,   35,
     11,32767,32767,32767,32767,32767,32767,32767,32767,32767,
  32767,32767,32767,32767,32767,32767,32767,32767,32767,32767,
  32767,32767,32767,   24,   25,32767,32767,32767,32767,32767,
  32767,32767,   10,   42,32767,32767,   17,32767
  ];

  private const yygoto:Array = [
      1,    2,    6,    3,    7,    9,   10,   87,   14,   15,
     16,   17,   18,   19,   43,   44,   84,   85,   86,    4,
      8,   46,   46,   46,   47,    0,   67
  ];
  private const YYGLAST:int = 27;

  private const yygcheck:Array = [
     12,   12,   12,   12,   12,   12,   12,   12,   12,   12,
     12,   12,   12,   12,   12,   12,   12,   12,   12,   12,
     12,   11,   11,   11,    4,   -1,    5
  ];

  private const yygbase:Array = [
      0,    0,    0,    0,   12,   13,    0,    0,    0,    0,
      0,   10,  -21
  ];

  private const yygdefault:Array = [
  -32768,   48,   42,   61,   45,   66,   52,   70,   71,   72,
     73,   53,    5
  ];

  private const yylhs:Array = [
      0,    1,    2,    2,    3,    3,    3,    3,    4,    4,
      5,    5,    5,    5,    5,    5,    5,    7,    7,    8,
      9,   10,    6,    6,   12,   12,   12,   12,   12,   12,
     12,   12,   12,   12,   12,   12,   12,   12,   12,   12,
     12,   12,   12,   11,   11
  ];

  private const yylen:Array = [
      1,    1,    0,    2,    3,    4,    1,    2,    1,    3,
      2,    1,    1,    1,    1,    1,    3,    4,    6,    2,
      6,    1,    1,    3,    3,    3,    3,    3,    3,    3,
      3,    3,    3,    3,    3,    3,    3,    3,    3,    1,
      1,    1,    1,    1,    4
  ];
  private const YYSTATES:int = 82;
  private const YYNLSTATES:int = 58;
  private const YYINTERRTOK:int = 1;
  private const YYUNEXPECTED:int = 32767;
  private const YYDEFAULT:int = -32766;

  private const YYDEFAULTSTACK:int = 512;

  /* Grow syntax and sematic stacks */
  private function growStack():void {
    var tmpsstk:Array = new Array(yysp * 2);
    var tmpastk:Array = new Array(yysp * 2);
    for (var i:int = 0; i < yysp; i++) {
      tmpsstk[i] = yysstk[i];
      tmpastk[i] = yyastk[i];
    }
    yysstk = tmpsstk;
    yyastk = tmpastk;
  }

  /*
   * Parser entry point
   */
  public function yyparse():int {
    var yyn:int;
    var yyp:int;
    var yyl:int;

    yyastk = new Array(YYDEFAULTSTACK);
    yysstk = new Array(YYDEFAULTSTACK);
    if (yyDumpParseTree)
      yyPTStack = new Array(YYDEFAULTSTACK);

    var yystate:int = 0;
    var yychar1:int = yychar = -1;

    yysp = 0;
    yysstk[yysp] = 0;
    yyerrflag = 0;
    for (;;) {
      YYTRACE_NEWSTATE(yystate, yychar1);
      if (yybase[yystate] == 0)
        yyn = yydefault[yystate];
      else {
        if (yychar < 0) {
          if ((yychar = yylex()) <= 0) yychar = 0;
          yychar1 = yychar < YYMAXLEX ? yytranslate[yychar] : YYBADCH;
          YYTRACE_READ(yychar1);
        }

        if (((yyn = yybase[yystate] + yychar1) >= 0
             && yyn < YYLAST && yycheck[yyn] == yychar1
             || (yystate < YY2TBLSTATE
                 && (yyn = yybase[yystate + YYNLSTATES] + yychar1) >= 0
                 && yyn < YYLAST && yycheck[yyn] == yychar1))
            && (yyn = yyaction[yyn]) != YYDEFAULT) {
          /*
           * >= YYNLSTATE: shift and reduce
           * > 0: shift
           * = 0: accept
           * < 0: reduce
           * = -YYUNEXPECTED: error
           */
          if (yyn > 0) {
            /* shift */
            YYTRACE_SHIFT(yychar1);
            if (++yysp >= yysstk.length)
              growStack();

            yysstk[yysp] = (int)(yystate = yyn);
            yyastk[yysp] = yylval;
            if (yyDumpParseTree)
	      yyPTStack[yysp] = new YYLeaf(this, yychar1, yylval);
            yychar1 = yychar = -1;

            if (yyerrflag > 0)
              yyerrflag--;
            if (yyn < YYNLSTATES)
              continue;
            
            /* yyn >= YYNLSTATES means shift-and-reduce */
            yyn -= YYNLSTATES;
          } else
            yyn = -yyn;
        } else
          yyn = yydefault[yystate];
      }
      
      for (;;) {
        /* reduce/error */
        if (yyn == 0) {
          /* accept */
          YYTRACE_ACCEPT();
	  if (yyDumpParseTree) {
	    yyPTStack[yysp].prettyPrint();
	  }
          return 0;
        }

	var yyparseerror:Boolean = true;
	if (yyn != YYUNEXPECTED) {
          /* reduce */
	  yyparseerror = false;
          yyl = yylen[yyn];
          yyval = yyastk[yysp-yyl+1];
          YYTRACE_REDUCE(yyn);
	  var yylrec:int = 0;
          /* Following line will be replaced by reduce actions */
          switch(yyn) {
          case 1:
{ } break;
          case 2:
{ yyval = topnode; } break;
          case 3:
{ yylrec++; gen.catNode(yyastk[yysp-(2-1)], yyastk[yysp-(2-2)]); } break;
          case 4:
{ yyval = gen.addLabel(yyastk[yysp-(3-1)]); gen.catNode(yyval, yyastk[yysp-(3-2)]); } break;
          case 5:
{ yyval = gen.addLabel(yyastk[yysp-(4-1)]); gen.catNode(yyval, yyastk[yysp-(4-3)]); } break;
          case 8:
{ yyval = yyastk[yysp-(1-1)]; } break;
          case 9:
{ yyval = gen.catNode(yyastk[yysp-(3-1)], yyastk[yysp-(3-3)]); } break;
          case 10:
{ yyval = gen.callFunc(yyastk[yysp-(2-1)], yyastk[yysp-(2-2)]); } break;
          case 11:
{ yyval = gen.callFunc(yyastk[yysp-(1-1)], null); } break;
          case 16:
{ yyval = gen.let(yyastk[yysp-(3-1)], yyastk[yysp-(3-3)]); } break;
          case 17:
{ yyval = gen.genIf(yyastk[yysp-(4-2)], yyastk[yysp-(4-4)], null); } break;
          case 18:
{ yyval = gen.genIf(yyastk[yysp-(6-2)], yyastk[yysp-(6-4)], yyastk[yysp-(6-6)]); } break;
          case 19:
{ yyval = gen.genGoto(yyastk[yysp-(2-2)]); } break;
          case 20:
{ yyval = gen.genFor(yyastk[yysp-(6-2)],yyastk[yysp-(6-4)],yyastk[yysp-(6-6)]); } break;
          case 21:
{ yyval = gen.genNext(); } break;
          case 22:
{ yyval = yyastk[yysp-(1-1)]; } break;
          case 23:
{ yyval = gen.catNode(yyastk[yysp-(3-1)], yyastk[yysp-(3-3)]); } break;
          case 24:
{ yyval = gen.calcPlus(yyastk[yysp-(3-1)], yyastk[yysp-(3-3)]); } break;
          case 25:
{ yyval = gen.calcMinus(yyastk[yysp-(3-1)], yyastk[yysp-(3-3)]); } break;
          case 26:
{ yyval = gen.calcMul(yyastk[yysp-(3-1)], yyastk[yysp-(3-3)]); } break;
          case 27:
{ yyval = gen.calcDiv(yyastk[yysp-(3-1)], yyastk[yysp-(3-3)]); } break;
          case 28:
{ yyval = gen.calcMod(yyastk[yysp-(3-1)], yyastk[yysp-(3-3)]); } break;
          case 29:
{ yyval = gen.calcMod(yyastk[yysp-(3-1)], yyastk[yysp-(3-3)]); } break;
          case 30:
{ yyval = gen.calcGt(yyastk[yysp-(3-1)], yyastk[yysp-(3-3)]); } break;
          case 31:
{ yyval = gen.calcGtEq(yyastk[yysp-(3-1)], yyastk[yysp-(3-3)]); } break;
          case 32:
{ yyval = gen.calcLt(yyastk[yysp-(3-1)], yyastk[yysp-(3-3)]); } break;
          case 33:
{ yyval = gen.calcLtEq(yyastk[yysp-(3-1)], yyastk[yysp-(3-3)]); } break;
          case 34:
{ yyval = gen.calcNotEq(yyastk[yysp-(3-1)], yyastk[yysp-(3-3)]); } break;
          case 35:
{ yyval = gen.calcEq(yyastk[yysp-(3-1)], yyastk[yysp-(3-3)]); } break;
          case 36:
{ yyval = gen.calcAnd(yyastk[yysp-(3-1)], yyastk[yysp-(3-3)]); } break;
          case 37:
{ yyval = gen.calcOr(yyastk[yysp-(3-1)], yyastk[yysp-(3-3)]); } break;
          case 38:
{ yyval = yyastk[yysp-(3-2)]; } break;
          case 39:
{ yyval = gen.pushNumber(yyastk[yysp-(1-1)]); } break;
          case 40:
{ yyval = gen.pushInt(yyastk[yysp-(1-1)]); } break;
          case 41:
{ yyval = gen.pushStr(yyastk[yysp-(1-1)]); } break;
          case 42:
{ yyval = gen.pushVariable(yyastk[yysp-(1-1)]); } break;
          case 43:
{ yyval = gen.getVariable(yyastk[yysp-(1-1)]); } break;
          case 44:
{ yyval = gen.getArray(yyastk[yysp-(4-1)], yyastk[yysp-(4-3)]); } break;
          }
	  if (!yyparseerror) {
	    if (yyDumpParseTree) {
	      if (yylrec != 0)
	        (yyPTStack[yysp-yyl+1]).appendKids(yyPTStack, yysp-yyl+2, yyl-1);
	      else
	        yyPTStack[yysp-yyl+1] = new YYNode(this, yylhs[yyn], yyPTStack, yysp-yyl+1, yyl);
	    }
            /* Goto - shift nonterminal */
            yysp -= yyl;
            yyn = yylhs[yyn];
            if ((yyp = yygbase[yyn] + yysstk[yysp]) >= 0 && yyp < YYGLAST
                && yygcheck[yyp] == yyn)
              yystate = yygoto[yyp];
            else
              yystate = yygdefault[yyn];
          
            if (++yysp >= yysstk.length)
              growStack();

            yysstk[yysp] = yystate;
            yyastk[yysp] = yyval;
	  }
	}

	if (yyparseerror) {
          /* error */
          switch (yyerrflag) {
          case 0:
            yyerror("syntax error");
          case 1:
          case 2:
            yyerrflag = 3;
            /* Pop until error-expecting state uncovered */

            while (!((yyn = yybase[yystate] + YYINTERRTOK) >= 0
                     && yyn < YYLAST && yycheck[yyn] == YYINTERRTOK
                     || (yystate < YY2TBLSTATE
                         && (yyn = yybase[yystate + YYNLSTATES] + YYINTERRTOK) >= 0
                         && yyn < YYLAST && yycheck[yyn] == YYINTERRTOK))) {
              if (yysp <= 0)
                return 1;
              yystate = yysstk[--yysp];
              YYTRACE_POP(yystate);
            }
            yyn = yyaction[yyn];
            YYTRACE_SHIFT(YYINTERRTOK);
            yysstk[++yysp] = (int)(yystate = yyn);
            if (yyDumpParseTree)
	      yyPTStack[yysp] = new YYLeaf(this, YYINTERRTOK, null);
            break;

          case 3:
            YYTRACE_DISCARD(yychar1);
            if (yychar1 == 0)
              return 1;
	    yychar1 = yychar = -1;
            break;
          }
        }
        
        if (yystate < YYNLSTATES)
          break;
        /* >= YYNLSTATES means shift-and-reduce */
        yyn = yystate - YYNLSTATES;
      }
    }
    return 0;
  }

}// end of class
}// end of package

  /** Parse Tree **/
  class YYParseTree {
    public function prettyPrint():void {
      prettyPrintX("", true);
    }

    public function prettyPrintX(head:String, last:Boolean):void {}
  }
  
  /** YYNode represents nonterminal symbol. **/
  class YYNode extends YYParseTree {
    private var id:int;
    private var nkids:int;
    private var kids:Array;
    private var parser:Object;

    public function YYNode(parser:Object, id:int, stack:Array, from:int, len:int) {
      this.parser = parser;
      this.id = id;
      nkids = len;
      kids = new Array(len);
      for (var i:int = 0; i < len; i++)
        kids[i] = stack[from + i];
    }


    public function appendKids(stack:Array, from:int, len:int):void {
      if (nkids + len > kids.length) {
        var size:int = kids.length * 2;
	if (size < nkids + len) size = nkids + len;
        var a:Array = new Array(size);
        for (var i:int = 0; i < nkids; i++)
          a[i] = kids[i];
        kids = a;
      }
      for (var j:int = 0; j < len; j++)
        kids[nkids + j] = stack[from + j];
      nkids += len;
    }


    public override function prettyPrintX(head:String, last:Boolean):void {
      var head2:String = head;
      if (head != "") {
        if (last)
          head2 = head + " +-"; /* L */
        else
          head2 = head + " +-"; /* T-rotated-left */
      }
      trace(head2 + parser.yynonterms[id]);
      head += last ? "   " : " | ";

      for (var i:int = 0; i < nkids; i++) {
        if (!parser.yydense)
          trace(head + " | ");
        if (i + 1 != nkids)
          kids[i].prettyPrintX(head, false);
        else
          kids[i].prettyPrintX(head, true);
      }
    }

    public function toString():String {
      var buf:String = "";
      buf += "(";
      buf += parser.yynonterms[id];
      for (var i:int = 0; i < nkids; i++) {
        buf += " ";
        buf += kids[i].toString();
      }
      buf + ")";
      return buf;
    }
  }

  /** YYLeaf represents terminal symbol. **/
  class YYLeaf extends YYParseTree {
    private var id:int;
    private var value:Object;
    private var parser:Object;
    
    public function YYLeaf(parser:Object, id:int, value:Object) {
      this.id = id;
      this.value = value;
      this.parser = parser;
    }

    public override function prettyPrintX(head:String, last:Boolean):void {
      var head2:String = head;
      if (head != "") {
        if (last)
          head2 = head + " +-"; /* L */
        else
          head2 = head + " +-"; /* T-rotated-left */
      }
      trace(head2 + toString());
    }

    public function toString():String {
      if (value != null)
        return parser.yyterminals[id] + "[" + value.toString() + "]";
      else
        return parser.yyterminals[id];
    }
  }


